# coding: utf-8

"""
    E2B API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr


class Sandbox(BaseModel):
    """
    Sandbox
    """

    template_id: StrictStr = Field(
        ...,
        alias="templateID",
        description="Identifier of the template from which is the sandbox created",
    )
    sandbox_id: StrictStr = Field(
        ..., alias="sandboxID", description="Identifier of the sandbox"
    )
    alias: Optional[StrictStr] = Field(None, description="Alias of the template")
    client_id: StrictStr = Field(
        ..., alias="clientID", description="Identifier of the client"
    )
    envd_v2: StrictBool = Field(
        ..., alias="envdV2", description="Whether the template contains envd v2"
    )
    additional_properties: Dict[str, Any] = {}
    __properties = ["templateID", "sandboxID", "alias", "clientID", "envdV2"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Sandbox:
        """Create an instance of Sandbox from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(
            by_alias=True, exclude={"additional_properties"}, exclude_none=True
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Sandbox:
        """Create an instance of Sandbox from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Sandbox.parse_obj(obj)

        _obj = Sandbox.parse_obj(
            {
                "template_id": obj.get("templateID"),
                "sandbox_id": obj.get("sandboxID"),
                "alias": obj.get("alias"),
                "client_id": obj.get("clientID"),
                "envd_v2": obj.get("envdV2"),
            }
        )
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj
